<?php
if (!defined( 'ABSPATH' )) exit;
class woo2app_core_api_shipping_methods {
	public function __construct(){
		add_action( 'init', array( $this , 'woo2app_api_regular_url' ));
		add_filter( 'query_vars', array( $this , 'woo2app_api_query_vars' ));
		add_action( 'parse_request', array( $this , 'woo2app_api_parse_request' ));
	}
	function woo2app_api_regular_url(){
		add_rewrite_rule('', 'index.php?GET_shipping_methods', 'top');
	}
	function woo2app_api_query_vars($query_vars){
		$query_vars[] = 'GET_shipping_methods';
		return $query_vars;
	}
	function woo2app_api_parse_request(&$wp){
		if ( array_key_exists( 'GET_shipping_methods' , $wp->query_vars ) ) {
			$this->woo2app_GET_shipping_methods();
			exit();
		}
		return;
	}
	function woo2app_GET_shipping_methods(){
		header('Content-Type: application/json; charset=utf-8');
		try {
			$in = $_POST['in'];
			$slashless = stripcslashes($in);
			$url_json = urldecode($slashless);
			$json = (array) json_decode($url_json);
			//var_dump($json);
			$package = array();
			$package['contents'] = array();
			$entity_body = $json;
			$line_items = $entity_body["items"];
			WC()->cart->empty_cart();
			foreach ($line_items as $line_item) {
				wc()->cart->add_to_cart( $line_item->product_id , $line_item->quantity , $line_item->variation_id  );
			}
			$user_use = 0;
			if($json['customer_id'] != -1){
				$coupon_code = $json['coupon_lines'][0]->code;
				$the_coupon = new WC_Coupon($coupon_code);
				$ids = $the_coupon->get_used_by();
				$user_use = sizeof( array_keys( $ids, $json['customer_id'] ) );
			}
			if(!$user_use ){
				if(isset($json['coupon_lines']) and $the_coupon->get_usage_limit_per_user()>$user_use){
					WC()->cart->add_discount( $json['coupon_lines'][0]->code);
				}
			}
			$cart = wc()->cart->get_shipping_packages();
			$ar = array();
			foreach($cart as $key){
				$ar = $key;
			}
			$item = array();
			$tax = 0;
			foreach ($ar['contents'] as $k){
				$item[] = $k;
				$tax += $k['line_tax'];
			}
			$ar["destination"]["country"] = $entity_body["shipping"]->country;
			$ar["destination"]["state"] = $entity_body["shipping"]->state;
			$sm =  wc()->shipping()->calculate_shipping_for_package($ar);
			$rates = array();
			if( isset($sm['rates']) ){
				foreach($sm["rates"] as $index ){
					$rates[] = array(
						'id' => $index->id,
						'label' => $index->label,
						'cost' => $index->cost,
						'taxes' => $index->taxes,
						'method_id' => $index->method_id,
					);
				}
			}
			$sm["rates"] = $rates;
			$sm["items"] = $item;
			$sm["discount"] = round(wc()->cart->discount_cart + wc()->cart->discount_cart_tax);
			$sm["tax"] = round(wc()->cart->tax_total + wc()->cart->discount_cart_tax  );
			$sm["kol"] = round(wc()->cart->subtotal_ex_tax);
			$sm["payment"] = round(wc()->cart->subtotal_ex_tax + $sm["tax"] - $sm["discount"]);
			unset($sm['contents']);
			WC()->session->set( 'applied_coupons', array() );
			echo json_encode($sm);
		} catch (\Exception $e) {
			wp_send_json_error(array('message' => $e->getMessage()));
		}
	}
}